
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Smart_link_clicksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const smart_link_clicks = await db.smart_link_clicks.create(
            {
                id: data.id || undefined,
        
        clicked_at: data.clicked_at
        ||
        null
            ,
            
        country: data.country
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        referrer: data.referrer
        ||
        null
            ,
            
        utm_source: data.utm_source
        ||
        null
            ,
            
        utm_campaign: data.utm_campaign
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await smart_link_clicks.setSmart_link( data.smart_link || null, {
            transaction,
        });
        
        await smart_link_clicks.setPlatform( data.platform || null, {
            transaction,
        });
        
        await smart_link_clicks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return smart_link_clicks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const smart_link_clicksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                clicked_at: item.clicked_at
            ||
            null
            ,
            
                country: item.country
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                referrer: item.referrer
            ||
            null
            ,
            
                utm_source: item.utm_source
            ||
            null
            ,
            
                utm_campaign: item.utm_campaign
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const smart_link_clicks = await db.smart_link_clicks.bulkCreate(smart_link_clicksData, { transaction });

        // For each item created, replace relation files
        

        return smart_link_clicks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const smart_link_clicks = await db.smart_link_clicks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.clicked_at !== undefined) updatePayload.clicked_at = data.clicked_at;
        
        
        if (data.country !== undefined) updatePayload.country = data.country;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.referrer !== undefined) updatePayload.referrer = data.referrer;
        
        
        if (data.utm_source !== undefined) updatePayload.utm_source = data.utm_source;
        
        
        if (data.utm_campaign !== undefined) updatePayload.utm_campaign = data.utm_campaign;
        
        
        updatePayload.updatedById = currentUser.id;

        await smart_link_clicks.update(updatePayload, {transaction});

        
        
        if (data.smart_link !== undefined) {
            await smart_link_clicks.setSmart_link(
              
              data.smart_link,
              
              { transaction }
            );
        }
        
        if (data.platform !== undefined) {
            await smart_link_clicks.setPlatform(
              
              data.platform,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await smart_link_clicks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return smart_link_clicks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const smart_link_clicks = await db.smart_link_clicks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of smart_link_clicks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of smart_link_clicks) {
                await record.destroy({transaction});
            }
        });


        return smart_link_clicks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const smart_link_clicks = await db.smart_link_clicks.findByPk(id, options);

        await smart_link_clicks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await smart_link_clicks.destroy({
            transaction
        });

        return smart_link_clicks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const smart_link_clicks = await db.smart_link_clicks.findOne(
            { where },
            { transaction },
        );

        if (!smart_link_clicks) {
            return smart_link_clicks;
        }

        const output = smart_link_clicks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.smart_link = await smart_link_clicks.getSmart_link({
            transaction
        });
        
        
        output.platform = await smart_link_clicks.getPlatform({
            transaction
        });
        
        
        output.organizations = await smart_link_clicks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.smart_links,
        as: 'smart_link',
        
        where: filter.smart_link ? {
          [Op.or]: [
            { id: { [Op.in]: filter.smart_link.split('|').map(term => Utils.uuid(term)) } },
            {
              slug: {
                [Op.or]: filter.smart_link.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.distribution_platforms,
        as: 'platform',
        
        where: filter.platform ? {
          [Op.or]: [
            { id: { [Op.in]: filter.platform.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.platform.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.country) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_clicks',
                        'country',
                        filter.country,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_clicks',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.referrer) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_clicks',
                        'referrer',
                        filter.referrer,
                    ),
                };
            }
            
            if (filter.utm_source) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_clicks',
                        'utm_source',
                        filter.utm_source,
                    ),
                };
            }
            
            if (filter.utm_campaign) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'smart_link_clicks',
                        'utm_campaign',
                        filter.utm_campaign,
                    ),
                };
            }
            

            
            

            
            if (filter.clicked_atRange) {
                const [start, end] = filter.clicked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    clicked_at: {
                    ...where.clicked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    clicked_at: {
                    ...where.clicked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.smart_link_clicks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'smart_link_clicks',
                        'referrer',
                        query,
                    ),
                ],
            };
        }

        const records = await db.smart_link_clicks.findAll({
            attributes: [ 'id', 'referrer' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['referrer', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.referrer,
        }));
    }

    
};

